shr.defineClass("shr.report.dateUtils", shr.framework.Core, {
	
	getdate : function (date) {
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		switch(date){
			case "today" : 
				return now.format("yyyy-MM-dd");
				break;
			case "current_month_star" : 
				return this.getMonthStartDate();
				break;
			case "current_month_end" :
				return this.getMonthEndDate();
				break;
			case "current_quarter_star" :
				return this.getQuarterStartDate();
				break;
			case "current_quarter_end" :
				return this.getQuarterEndDate();
				break;
			case "current_annual_star" :
				return this.getAnnualStartDate();
				break;
			case "current_annual_end" :
				return this.getAnnualEndDate();
				break;
			case "last_month_star" :
				return this.getLastMonthStartDate();
				break;
			case "last_month_end" : 
				return this.getLastMonthEndDate();
				break;
			case "last_quarter_star" :
				var t_date = new Date(this.getQuarterStartDate()); 
				return this.getPriorSeasonFirstDay(nowYear,t_date.getMonth());
				break;
			case "last_quarter_end" :
				var t_date = new Date(this.getQuarterStartDate()); 
				return this.getPriorSeasonEndDay(nowYear,t_date.getMonth());
				break;
			case "last_annual_star" :
				return this.getLastAnnualStartDate();
				break;
			case "last_annual_end" :
				return this.getLastAnnualEndDate();
				break;
			default:
				return date;
				break;
		}
	},	
	
	
	formatDate :function (date) {  
		var myyear = date.getFullYear();  
		var mymonth = date.getMonth()+1;  
		var myweekday = date.getDate();  
		  
		if(mymonth < 10){  
		mymonth = "0" + mymonth;  
		}  
		if(myweekday < 10){  
		myweekday = "0" + myweekday;  
		}  
		return (myyear+"-"+mymonth + "-" + myweekday);  
	},  
  
	//获得某月的天数  
	getMonthDays :function (myMonth){
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getYear();  
		var lastMonth = lastMonthDate.getMonth(); 
		
		var monthStartDate = new Date(nowYear, myMonth, 1);  
		var monthEndDate = new Date(nowYear, myMonth + 1, 1);  
		var days = (monthEndDate - monthStartDate)/(1000 * 60 * 60 * 24);  
		return days;  
	},  
  
	//获得本季度的开端月份  
	getQuarterStartMonth :function (){
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getYear();  
		var lastMonth = lastMonthDate.getMonth();  	
		var quarterStartMonth = 0;  
		if(nowMonth<3){  
		quarterStartMonth = 0;  
		}  
		if(2<nowMonth && nowMonth<6){  
		quarterStartMonth = 3;  
		}  
		if(5<nowMonth && nowMonth<9){  
		quarterStartMonth = 6;  
		}  
		if(nowMonth>8){  
		quarterStartMonth = 9;  
		}  
		return quarterStartMonth;  
	},  
	  
	
	//获得本月的开端日期  
	getMonthStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var monthStartDate = new Date(nowYear, nowMonth, 1);  
		return monthStartDate.format("yyyy-MM-dd")	
	},  
	 
	//获得上月的开端日期  
	getLastMonthStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		var monthStartDate = new Date(nowYear, nowMonth-1, 1);  
		return monthStartDate.format("yyyy-MM-dd")	
	},  
	 
	//获得本月的停止日期  
	getMonthEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var monthEndDate = new Date(nowYear, nowMonth, this.getMonthDays(nowMonth));  
		return monthEndDate.format("yyyy-MM-dd");	
	}, 
	
	//获得上月的停止日期  
	getLastMonthEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		var monthEndDate = new Date(nowYear, nowMonth-1, this.getMonthDays(nowMonth));  
		return monthEndDate.format("yyyy-MM-dd");	
	},  	
	  
	//获得上月开端时候  
	getLastMonthStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getFullYear();  
		var lastMonth = lastMonthDate.getMonth();  	
		var lastMonthStartDate = new Date(lastYear, lastMonth, 1);  
		return lastMonthStartDate.format("yyyy-MM-dd");	
	},  
	  
	//获得上月停止时候  
	getLastMonthEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getFullYear();  
		var lastMonth = lastMonthDate.getMonth();  	
		var lastMonthEndDate = new Date(lastYear, lastMonth, this.getMonthDays(lastMonth));  
		return lastMonthEndDate.format("yyyy-MM-dd");	
		
	}, 
	  
	//获得本季度的开端日期  
	getQuarterStartDate :function (){  
		var now = new Date(); //当前日期   
		var nowYear = now.getFullYear(); //当前年  
		var quarterStartDate = new Date(nowYear, this.getQuarterStartMonth(), 1);  
		return quarterStartDate.format("yyyy-MM-dd");	
		
	}, 
	
	
	//获得上季度季度的开端日期  
	getLastQuarterStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var quarterStartDate = new Date(nowYear, this.getQuarterStartMonth(), 1);  
		return quarterStartDate.format("yyyy-MM-dd");	
	}, 
	
	  
	//获的本季度的停止日期  
	getQuarterEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var quarterEndMonth = this.getQuarterStartMonth() + 2;  
		var quarterStartDate = new Date(nowYear, quarterEndMonth, this.getMonthDays(quarterEndMonth));  
		return quarterStartDate.format("yyyy-MM-dd");	
	}, 

	//获取本年度初
	getAnnualStartDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear, 0, 1);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	//获取本年度初
	getLastAnnualStartDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear-1, 0, 1);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	//获取本年度末
	getAnnualEndDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear, 11, 31);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	
	//获取上年度末
	getLastAnnualEndDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear-1, 11, 31);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	 /**
     * 得到上季度的起始日期
     * year 这个年应该是运算后得到的当前本季度的年份
     * month 这个应该是运算后得到的当前季度的开始月份
     * */ 
   getPriorSeasonFirstDay : function(year,month){ 
        var quarterMonthStart=0; 
        var spring=0; //春  
        var summer=3; //夏  
        var fall=6;   //秋  
        var winter=9;//冬  
        //月份从0-11  
        switch(month){//季度的其实月份  
        case spring: 
            //如果是第一季度则应该到去年的冬季  
              year--; 
              month=winter; 
            break; 
        case summer: 
            month=spring; 
            break; 
        case fall: 
            month=summer; 
            break; 
        case winter: 
            month=fall; 
            break; 
             
        };  
        return (new Date(year,month,1)).format("yyyy-MM-dd"); 
    },
	
	 /**
     * 得到上季度的结束日期
     * year 这个年应该是运算后得到的当前本季度的年份
     * month 这个应该是运算后得到的当前季度的开始月份
     * */ 
   getPriorSeasonEndDay : function(year,month){ 
        var quarterMonthStart=0; 
        var spring=0; //春  
        var summer=3; //夏  
        var fall=6;   //秋  
        var winter=9;//冬  
        //月份从0-11  
        switch(month){//季度的其实月份  
        case spring: 
            //如果是第一季度则应该到去年的冬季  
              year--; 
              month=winter; 
            break; 
        case summer: 
            month=spring; 
            break; 
        case fall: 
            month=summer; 
            break; 
        case winter: 
            month=fall; 
            break; 
             
        };  
        return (new Date(year,month+2,this.getMonthDays(month))).format("yyyy-MM-dd"); 
    },
});